import { Context } from 'aws-lambda';
import { DynamicModuleLoader } from '../types/DynamicLoader';
import { ActionProcessorListResolver } from './lambdaConfig';
export declare const getAPIGatewayEventExecutor: (dynamicModuleLoader: DynamicModuleLoader, getCustomActionProcessors?: ActionProcessorListResolver) => (event: import("aws-lambda").APIGatewayProxyEvent, context: Context) => Promise<{
    statusCode: any;
    body: string;
    headers: any;
}>;
export declare const executeAPIGatewayEvent: (event: import("aws-lambda").APIGatewayProxyEvent, context: Context) => Promise<{
    statusCode: any;
    body: string;
    headers: any;
}>;
