import { EventBridgeEvent, Context } from 'aws-lambda';
import { DynamicModuleLoader } from '../types/DynamicLoader';
import { ActionProcessorListResolver } from './lambdaConfig';
export declare const getEventBridgeEventExecutor: (dynamicModuleLoader: DynamicModuleLoader, getCustomActionProcessors?: ActionProcessorListResolver) => (event: EventBridgeEvent<string, void>, context: Context) => Promise<void>;
export declare const executeEventBridgeEvent: (event: EventBridgeEvent<string, void>, context: Context) => Promise<void>;
